package com.mortals.xhx.module.matter.dao.ibatis;

import com.mortals.framework.model.TableParam;
import com.mortals.framework.model.TableStrategy;
import com.mortals.framework.util.DateUtils;
import com.mortals.framework.util.StringUtils;
import org.springframework.util.ObjectUtils;
import org.springframework.stereotype.Repository;
import com.mortals.xhx.module.matter.dao.MatterDatumDao;
import com.mortals.xhx.module.matter.model.MatterDatumEntity;
import java.util.Date;
import com.mortals.framework.dao.ibatis.SubmeterDaoImpl;
import com.mortals.xhx.module.matter.model.MatterDatumQuery;
/**
 * 事项申请材料DaoImpl DAO接口
 *
 * @author zxfei
 * @date 2021-09-30
 */
@Repository("matterDatumDao")
public class MatterDatumDaoImpl extends SubmeterDaoImpl<MatterDatumEntity,Long> implements MatterDatumDao {

    @Override
    protected TableStrategy getTableStrategy() {
        return new TableStrategy("mortals_xhx_matter_datum_${unionTime}", TableStrategy.STRATEGY_BY_MONTH, 3);
    }

    @Override
    public TableParam getTableParam(MatterDatumEntity makeTableNameOfentity) {
        TableParam tableParam = new TableParam();
        if (!ObjectUtils.isEmpty(makeTableNameOfentity.getCreateTime())) {
            tableParam.unionTime = makeTableNameOfentity.getCreateTime();
        } else if (makeTableNameOfentity instanceof MatterDatumQuery) {
            MatterDatumQuery MatterDatumQuery = (MatterDatumQuery) makeTableNameOfentity;
            if (StringUtils.isNotEmpty(MatterDatumQuery.getCreateTimeStart())) {
                tableParam.unionTime = DateUtils.StrToDate(MatterDatumQuery.getCreateTimeStart());
            } else if (StringUtils.isNotEmpty(MatterDatumQuery.getCreateTimeEnd())) {
                tableParam.unionTime = DateUtils.StrToDate(MatterDatumQuery.getCreateTimeEnd());
            }
        }
        if (ObjectUtils.isEmpty(tableParam.unionTime)) {
            tableParam.unionTime = new Date();
        }
        return tableParam;
    }

}